unit rDBGridSorter_UniDAC;

{<
  rDBGridSorter_UniDAC unit contains TrDBGridSorter_UniDAC - sorter for TMemDataSet
  used by rDBGrid to sort UniDac datasets.

  @author(Rosinsky Software - <http://www.rosinsky.cz/delphi>)
  @created(Oct 2006 - Jun 2013)
  @lastmod(Dec 2015)
}

interface

uses
  Windows, Messages, SysUtils, Graphics, Classes, Controls, Menus, Dialogs,
  StdCtrls, Forms, DB, Variants, rDBGrid, MemDS;

type
  { sorter for TMemDataSet used by rDBGrid to sort UniDac datasets }
  TrDBGridSorter_UniDAC = class(TrDBGridCustomSorter)
  public
    function SetSort_CreateIndex(DataSet: TDataSet; const SortString: string; const SortFields: string; const DescendingFields: string): boolean; override;
  end;

procedure Register;

implementation

{$R *.res}
uses RosiCompGlobalCfg;

procedure Register;
begin
  RegisterComponents('Rosi DB', [TrDBGridSorter_UniDAC]);
end;

function TrDBGridSorter_UniDAC.SetSort_CreateIndex(DataSet: TDataSet; const SortString: string; const SortFields: string; const DescendingFields: string)
  : boolean;
var
  DS: TMemDataSet;
begin
  if (DataSet is TMemDataSet) then
  begin
    DS:=DataSet as TMemDataSet;
    DS.IndexFieldNames:=SortString;
    Result:=true;
  end
  else
    Result:= inherited;
end;

end.
